import java.util.Random;

public class GRASP {
	
	
	public static void run(StowagePlan stowagePlan, Cargo[] Cargoes){
		long startTime = System.currentTimeMillis();
		long maxRunTime = 20000; //milliseconds
		int maxIterations = 30000000;
		int deltaWeight = 10;
		
		int prevAreaNotPlaced = 0;
		int tempSum = 0;
		Random rand = new Random();
		int randomNum;
		int paramChoice;
	
		//Initial values given by testing.
		int ParamSearchDir = 0;
		double ParamRandom = 0;
		int ParamCandidateListLength = 1;
		int ParamAreaOrSquares = 0;
		int randomChosen = 0;
		
		
		//Calculating number of cargoes carried.
		int cargoesCarried = 0;
		for (int c = 0; c < stowagePlan.nCargoes; c++) {
			if (c<stowagePlan.nCargoesM || (c>=stowagePlan.nCargoesM && stowagePlan.OptionalSetEvaluated.CargoesCarried[c-stowagePlan.nCargoesM]==1)){
				cargoesCarried++;
			}
		}
		
		//Weight of drawing chance.
		int[] WeightParamSearchDir = {1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000};
		int[] WeightParamRandom = {1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000};
		int[] WeightParamCandidateListLength = new int [5]; //Her gir det ogs mening  ha cargoesCarried.
		for (int c = 0; c < WeightParamCandidateListLength.length; c++) {
			WeightParamCandidateListLength[c] = (int) Math.ceil(1000/(c+1)); 
			//WeightParamCandidateListLength[c] = 1000; 
		}
		
		int[] WeightParamAreaOrSquares = {1000,1000};
	
		System.out.println("Ite Dir Ran Lis Obj Not ");
		for (int n = 0; n < maxIterations ; n++) {
			if ((System.currentTimeMillis()-startTime)>=maxRunTime){
				break;
			}
			
			//Initial sker vi gjennom alle retninger for begge objectives, med 0 random og 1 i list length. Mulig dette kan finne gunstige lsninger fr randomsearch.
			if (n == 0){
				for (int p = 0; p < 8 ; p++) {
					for (int o = 0; o < 2 ; o++) {
						ParamSearchDir = p;
						ParamRandom = 0;
						ParamCandidateListLength = 1;
						ParamAreaOrSquares = o;
						stowagePlan.GRASPconstruction(stowagePlan.possibleSquares, Cargoes, ParamSearchDir, ParamRandom, ParamCandidateListLength, ParamAreaOrSquares);
						System.out.println(n+ "   " + ParamSearchDir+ "   " + (ParamRandom) + " " + (ParamCandidateListLength) + "   " + ParamAreaOrSquares + "    " + stowagePlan.areaNotPlaced);
						n++;
						if (stowagePlan.areaNotPlaced == 0){
							break;
						}
					}
					if (stowagePlan.areaNotPlaced == 0){
						break;
					}
				}
				if (stowagePlan.areaNotPlaced == 0){
					break;
				}
			}
			//Hvis initiell sking ikke gikk, sier vi at lengden p listen m vre lengre enn 1.
			WeightParamCandidateListLength[0]=0;
						
			//Choose which parameter to update
			paramChoice = rand.nextInt(4);
			if (paramChoice == 0) {
				//DRAW searchdir
				tempSum=0;
				for (int l = 0; l < WeightParamSearchDir.length ; l++) {
					tempSum = tempSum + WeightParamSearchDir[l];
				}
				if (tempSum == 0){
					ParamSearchDir = rand.nextInt(8);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamSearchDir.length ; l++) {
						tempSum = tempSum + WeightParamSearchDir[l];
						if (tempSum>=randomNum){
							ParamSearchDir = l;
							break;
						}
					}
				}
	        } else if (paramChoice == 1) {
	        	tempSum=0;
				for (int l = 0; l < WeightParamRandom.length ; l++) {
					tempSum = tempSum + WeightParamRandom[l];
				}
				if (tempSum == 0){
					double l1 = rand.nextInt(WeightParamRandom.length-1);
					ParamRandom = l1/(WeightParamRandom.length-1);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamRandom.length ; l++) {
						tempSum = tempSum + WeightParamRandom[l];
						if (tempSum>=randomNum){
							double l1 = l;
							randomChosen = l;
							ParamRandom = l1/(WeightParamRandom.length-1);
							break;
						}
					}
				}
				
	        } else if (paramChoice == 2) {
	        	tempSum=0;
				for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
					tempSum = tempSum + WeightParamCandidateListLength[l];
				}
				if (tempSum == 0){
					ParamCandidateListLength = rand.nextInt(cargoesCarried)+1;
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
						tempSum = tempSum + WeightParamCandidateListLength[l];
						if (tempSum>=randomNum){
							ParamCandidateListLength = l+1;
							break;
						}
					}
				}
				
	        } else {
	        	tempSum=0;
				for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
					tempSum = tempSum + WeightParamAreaOrSquares[l];
				}
				if (tempSum == 0){
					ParamAreaOrSquares = rand.nextInt(2);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
						tempSum = tempSum + WeightParamAreaOrSquares[l];
						if (tempSum>=randomNum){
							ParamAreaOrSquares = l;
							break;
						}
					}
				}
	        }
			
			stowagePlan.GRASPconstruction(stowagePlan.possibleSquares, Cargoes, ParamSearchDir, ParamRandom, ParamCandidateListLength, ParamAreaOrSquares);
			
			//Printing some information
			System.out.println(n+ "   " + ParamSearchDir+ "   " + (ParamRandom) + " " + (ParamCandidateListLength) + "   " + ParamAreaOrSquares + "    " + stowagePlan.areaNotPlaced);
			
			if (stowagePlan.areaNotPlaced == 0){
				//System.out.println("VI ER FERDIG!! Area not placed = " + stowagePlan.areaNotPlaced);
				break;
			} else {
				//UPDATE WEIGHTS;
				
				if (n!=0){
					if (stowagePlan.areaNotPlaced>prevAreaNotPlaced){
						if (paramChoice == 0) {
							WeightParamSearchDir[ParamSearchDir]=WeightParamSearchDir[ParamSearchDir]-deltaWeight;
							if (WeightParamSearchDir[ParamSearchDir] < 100){
								WeightParamSearchDir[ParamSearchDir]=100;
							}
							//System.out.println("Searchdir reduced");
				        } else if (paramChoice == 1) {
				        	WeightParamRandom[randomChosen]=WeightParamRandom[randomChosen]-deltaWeight;
				        	//System.out.println("Random reduced");
				        	if (WeightParamRandom[randomChosen] < 100){
				        		WeightParamRandom[randomChosen]=100;
							}
				        } else if (paramChoice == 2) {
				        	WeightParamCandidateListLength[ParamCandidateListLength-1]=WeightParamCandidateListLength[ParamCandidateListLength-1]-deltaWeight;
				        	//System.out.println("List reduced");
				        	if (WeightParamCandidateListLength[ParamCandidateListLength-1] < 100){
				        		WeightParamCandidateListLength[ParamCandidateListLength-1]=100;
							}
				        } else {
				        	WeightParamAreaOrSquares[ParamAreaOrSquares]=WeightParamAreaOrSquares[ParamAreaOrSquares]-deltaWeight;
				        	//System.out.println("Obj reduced");
				        	if (WeightParamAreaOrSquares[ParamAreaOrSquares] < 100){
				        		WeightParamAreaOrSquares[ParamAreaOrSquares]=100;
							}
				        }
					}
					if (stowagePlan.areaNotPlaced<prevAreaNotPlaced){
						if (paramChoice == 0) {
							WeightParamSearchDir[ParamSearchDir]=WeightParamSearchDir[ParamSearchDir]+deltaWeight;
							//System.out.println("Searchdir increased");
				        } else if (paramChoice == 1) {
				        	WeightParamRandom[randomChosen]=WeightParamRandom[randomChosen]+deltaWeight;
				        	//System.out.println("Random increased");
				        } else if (paramChoice == 2) {
				        	WeightParamCandidateListLength[ParamCandidateListLength-1]=WeightParamCandidateListLength[ParamCandidateListLength-1]+deltaWeight;
				        	//System.out.println("List increased");
				        } else {
				        	WeightParamAreaOrSquares[ParamAreaOrSquares]=WeightParamAreaOrSquares[ParamAreaOrSquares]+deltaWeight;
				        	//System.out.println("Obj increased");
				        }
					}
				}
				
				prevAreaNotPlaced = stowagePlan.areaNotPlaced;
			}
		}
		//printParameters(WeightParamSearchDir,WeightParamRandom,WeightParamCandidateListLength,WeightParamAreaOrSquares);
		
	}


	public static void runWithTimer(StowagePlan stowagePlan, Cargo[] Cargoes, long runtime, int deltaWeight, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares){
		int[] WeightParamSearchDir = new int[InitialWeightParamSearchDir.length];
		int[] WeightParamRandom = new int[InitialWeightParamRandom.length];
		int[] WeightParamCandidateListLength = new int[InitialWeightParamCandidateListLength.length]; 
		int[] WeightParamAreaOrSquares = new int[InitialWeightParamAreaOrSquares.length];
		for (int i = 0; i < InitialWeightParamSearchDir.length; i++){
			WeightParamSearchDir[i]=InitialWeightParamSearchDir[i];
		}
		for (int i = 0; i < InitialWeightParamRandom.length; i++){
			WeightParamRandom[i]=InitialWeightParamRandom[i];
		}
		for (int i = 0; i < InitialWeightParamCandidateListLength.length; i++){
			WeightParamCandidateListLength[i]=InitialWeightParamCandidateListLength[i];
		}
		for (int i = 0; i < InitialWeightParamAreaOrSquares.length; i++){
			WeightParamAreaOrSquares[i]=InitialWeightParamAreaOrSquares[i];
		}		
		long startTime = System.currentTimeMillis();
		long maxRunTime = runtime; //milliseconds
		int maxIterations = 30000000;
		
		
		int prevAreaNotPlaced = 0;
		int tempSum = 0;
		Random rand = new Random();
		int randomNum;
		int paramChoice;
	
		//Initial values given by testing.
		int ParamSearchDir = 0;
		double ParamRandom = 0;
		int ParamCandidateListLength = 1;
		int ParamAreaOrSquares = 0;
		int randomChosen = 0;
		
		
		//Calculating number of cargoes carried.
		int cargoesCarried = 0;
		for (int c = 0; c < stowagePlan.nCargoes; c++) {
			if (c<stowagePlan.nCargoesM || (c>=stowagePlan.nCargoesM && stowagePlan.OptionalSetEvaluated.CargoesCarried[c-stowagePlan.nCargoesM]==1)){
				cargoesCarried++;
			}
		}
		
		//Weight of drawing chance.
		
	
		//System.out.println("Ite Dir Ran Lis Obj Not ");
		for (int n = 0; n < maxIterations ; n++) {
			if ((System.currentTimeMillis()-startTime)>=maxRunTime){
				break;
			}
			
			//Initial sker vi gjennom alle retninger for begge objectives, med 0 random og 1 i list length. Mulig dette kan finne gunstige lsninger fr randomsearch.
			if (n == 0){
				for (int p = 0; p < 8 ; p++) {
					for (int o = 0; o < 2 ; o++) {
						ParamSearchDir = p;
						ParamRandom = 0;
						ParamCandidateListLength = 1;
						ParamAreaOrSquares = o;
						stowagePlan.GRASPconstruction(stowagePlan.possibleSquares, Cargoes, ParamSearchDir, ParamRandom, ParamCandidateListLength, ParamAreaOrSquares);
						//System.out.println(n+ "   " + ParamSearchDir+ "   " + (ParamRandom) + " " + (ParamCandidateListLength) + "   " + ParamAreaOrSquares + "    " + stowagePlan.areaNotPlaced);
						n++;
						if (stowagePlan.areaNotPlaced == 0){
							break;
						}
					}
					if (stowagePlan.areaNotPlaced == 0){
						break;
					}
				}
				if (stowagePlan.areaNotPlaced == 0){
					break;
				}
			}
			//Hvis initiell sking ikke gikk, sier vi at lengden p listen m vre lengre enn 1.
			WeightParamCandidateListLength[0]=0;
						
			//Choose which parameter to update
			paramChoice = rand.nextInt(4);
			if (paramChoice == 0) {
				//DRAW searchdir
				tempSum=0;
				for (int l = 0; l < WeightParamSearchDir.length ; l++) {
					tempSum = tempSum + WeightParamSearchDir[l];
				}
				if (tempSum == 0){
					ParamSearchDir = rand.nextInt(8);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamSearchDir.length ; l++) {
						tempSum = tempSum + WeightParamSearchDir[l];
						if (tempSum>=randomNum){
							ParamSearchDir = l;
							break;
						}
					}
				}
	        } else if (paramChoice == 1) {
	        	tempSum=0;
				for (int l = 0; l < WeightParamRandom.length ; l++) {
					tempSum = tempSum + WeightParamRandom[l];
				}
				if (tempSum == 0){
					double l1 = rand.nextInt(WeightParamRandom.length-1);
					ParamRandom = l1/(WeightParamRandom.length-1);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamRandom.length ; l++) {
						tempSum = tempSum + WeightParamRandom[l];
						if (tempSum>=randomNum){
							double l1 = l;
							randomChosen = l;
							ParamRandom = l1/(WeightParamRandom.length-1);
							break;
						}
					}
				}
				
	        } else if (paramChoice == 2) {
	        	tempSum=0;
				for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
					tempSum = tempSum + WeightParamCandidateListLength[l];
				}
				if (tempSum == 0){
					ParamCandidateListLength = rand.nextInt(cargoesCarried)+1;
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
						tempSum = tempSum + WeightParamCandidateListLength[l];
						if (tempSum>=randomNum){
							ParamCandidateListLength = l+1;
							break;
						}
					}
				}
				
	        } else {
	        	tempSum=0;
				for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
					tempSum = tempSum + WeightParamAreaOrSquares[l];
				}
				if (tempSum == 0){
					ParamAreaOrSquares = rand.nextInt(2);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
						tempSum = tempSum + WeightParamAreaOrSquares[l];
						if (tempSum>=randomNum){
							ParamAreaOrSquares = l;
							break;
						}
					}
				}
	        }
			//System.out.println(ParamRandom);
			stowagePlan.GRASPconstruction(stowagePlan.possibleSquares, Cargoes, ParamSearchDir, ParamRandom, ParamCandidateListLength, ParamAreaOrSquares);
			
			//Printing some information
			//System.out.println(n+ "   " + ParamSearchDir+ "   " + (ParamRandom) + " " + (ParamCandidateListLength) + "   " + ParamAreaOrSquares + "    " + stowagePlan.areaNotPlaced);
			
			if (stowagePlan.areaNotPlaced == 0){
				//System.out.println("VI ER FERDIG!! Area not placed = " + stowagePlan.areaNotPlaced);
				break;
			} else {
				//UPDATE WEIGHTS;
				
				if (n!=0){
					if (stowagePlan.areaNotPlaced>prevAreaNotPlaced){
						if (paramChoice == 0) {
							WeightParamSearchDir[ParamSearchDir]=WeightParamSearchDir[ParamSearchDir]-deltaWeight;
							if (WeightParamSearchDir[ParamSearchDir] < 100){
								WeightParamSearchDir[ParamSearchDir]=100;
							}
							//System.out.println("Searchdir reduced");
				        } else if (paramChoice == 1) {
				        	WeightParamRandom[randomChosen]=WeightParamRandom[randomChosen]-deltaWeight;
				        	//System.out.println("Random reduced");
				        	if (WeightParamRandom[randomChosen] < 100){
				        		WeightParamRandom[randomChosen]=100;
							}
				        } else if (paramChoice == 2) {
				        	WeightParamCandidateListLength[ParamCandidateListLength-1]=WeightParamCandidateListLength[ParamCandidateListLength-1]-deltaWeight;
				        	//System.out.println("List reduced");
				        	if (WeightParamCandidateListLength[ParamCandidateListLength-1] < 100){
				        		WeightParamCandidateListLength[ParamCandidateListLength-1]=100;
							}
				        } else {
				        	WeightParamAreaOrSquares[ParamAreaOrSquares]=WeightParamAreaOrSquares[ParamAreaOrSquares]-deltaWeight;
				        	//System.out.println("Obj reduced");
				        	if (WeightParamAreaOrSquares[ParamAreaOrSquares] < 100){
				        		WeightParamAreaOrSquares[ParamAreaOrSquares]=100;
							}
				        }
					}
					if (stowagePlan.areaNotPlaced<prevAreaNotPlaced){
						if (paramChoice == 0) {
							WeightParamSearchDir[ParamSearchDir]=WeightParamSearchDir[ParamSearchDir]+deltaWeight;
							//System.out.println("Searchdir increased");
				        } else if (paramChoice == 1) {
				        	WeightParamRandom[randomChosen]=WeightParamRandom[randomChosen]+deltaWeight;
				        	//System.out.println("Random increased");
				        } else if (paramChoice == 2) {
				        	WeightParamCandidateListLength[ParamCandidateListLength-1]=WeightParamCandidateListLength[ParamCandidateListLength-1]+deltaWeight;
				        	//System.out.println("List increased");
				        } else {
				        	WeightParamAreaOrSquares[ParamAreaOrSquares]=WeightParamAreaOrSquares[ParamAreaOrSquares]+deltaWeight;
				        	//System.out.println("Obj increased");
				        }
					}
				}
				
				prevAreaNotPlaced = stowagePlan.areaNotPlaced;
			}
		}
		//printParameters(WeightParamSearchDir,WeightParamRandom,WeightParamCandidateListLength,WeightParamAreaOrSquares);
		
	}


	public static void runItercounter(StowagePlan stowagePlan, Cargo[] Cargoes){
		long startTime = System.currentTimeMillis();
		long maxRunTime = 20000; //milliseconds
		int maxIterations = 30000000;
		int deltaWeight = 10;
		
		int prevAreaNotPlaced = 0;
		int tempSum = 0;
		Random rand = new Random();
		int randomNum;
		int paramChoice;
	
		//Initial values given by testing.
		int ParamSearchDir = 0;
		double ParamRandom = 0;
		int ParamCandidateListLength = 1;
		int ParamAreaOrSquares = 0;
		int randomChosen = 0;
		
		
		//Calculating number of cargoes carried.
		int cargoesCarried = 0;
		for (int c = 0; c < stowagePlan.nCargoes; c++) {
			if (c<stowagePlan.nCargoesM || (c>=stowagePlan.nCargoesM && stowagePlan.OptionalSetEvaluated.CargoesCarried[c-stowagePlan.nCargoesM]==1)){
				cargoesCarried++;
			}
		}
		
		//Weight of drawing chance.
		int[] WeightParamSearchDir = {1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000};
		int[] WeightParamRandom = {1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000};
		int[] WeightParamCandidateListLength = new int [5]; //Her gir det ogs mening  ha cargoesCarried.
		for (int c = 0; c < WeightParamCandidateListLength.length; c++) {
			WeightParamCandidateListLength[c] = (int) Math.ceil(1000/(c+1)); 
			//WeightParamCandidateListLength[c] = 1000; 
		}
		
		int[] WeightParamAreaOrSquares = {1000,1000};
		long totalIter = 14;
		//System.out.println("Ite Dir Ran Lis Obj Not ");
		for (int n = 0; n < maxIterations ; n++) {
			totalIter++;
			if ((System.currentTimeMillis()-startTime)>=maxRunTime){
				break;
			}
			
			//Initial sker vi gjennom alle retninger for begge objectives, med 0 random og 1 i list length. Mulig dette kan finne gunstige lsninger fr randomsearch.
			if (n == 0){
				for (int p = 0; p < 8 ; p++) {
					for (int o = 0; o < 2 ; o++) {
						ParamSearchDir = p;
						ParamRandom = 0;
						ParamCandidateListLength = 1;
						ParamAreaOrSquares = o;
						stowagePlan.GRASPconstruction(stowagePlan.possibleSquares, Cargoes, ParamSearchDir, ParamRandom, ParamCandidateListLength, ParamAreaOrSquares);
						//System.out.println(n+ "   " + ParamSearchDir+ "   " + (ParamRandom) + " " + (ParamCandidateListLength) + "   " + ParamAreaOrSquares + "    " + stowagePlan.areaNotPlaced);
						n++;
						if (stowagePlan.areaNotPlaced == 0){
							break;
						}
					}
					if (stowagePlan.areaNotPlaced == 0){
						break;
					}
				}
				if (stowagePlan.areaNotPlaced == 0){
					break;
				}
			}
			//Hvis initiell sking ikke gikk, sier vi at lengden p listen m vre lengre enn 1.
			WeightParamCandidateListLength[0]=0;
						
			//Choose which parameter to update
			paramChoice = rand.nextInt(4);
			if (paramChoice == 0) {
				//DRAW searchdir
				tempSum=0;
				for (int l = 0; l < WeightParamSearchDir.length ; l++) {
					tempSum = tempSum + WeightParamSearchDir[l];
				}
				if (tempSum == 0){
					ParamSearchDir = rand.nextInt(8);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamSearchDir.length ; l++) {
						tempSum = tempSum + WeightParamSearchDir[l];
						if (tempSum>=randomNum){
							ParamSearchDir = l;
							break;
						}
					}
				}
	        } else if (paramChoice == 1) {
	        	tempSum=0;
				for (int l = 0; l < WeightParamRandom.length ; l++) {
					tempSum = tempSum + WeightParamRandom[l];
				}
				if (tempSum == 0){
					double l1 = rand.nextInt(WeightParamRandom.length-1);
					ParamRandom = l1/(WeightParamRandom.length-1);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamRandom.length ; l++) {
						tempSum = tempSum + WeightParamRandom[l];
						if (tempSum>=randomNum){
							double l1 = l;
							randomChosen = l;
							ParamRandom = l1/(WeightParamRandom.length-1);
							break;
						}
					}
				}
				
	        } else if (paramChoice == 2) {
	        	tempSum=0;
				for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
					tempSum = tempSum + WeightParamCandidateListLength[l];
				}
				if (tempSum == 0){
					ParamCandidateListLength = rand.nextInt(cargoesCarried)+1;
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
						tempSum = tempSum + WeightParamCandidateListLength[l];
						if (tempSum>=randomNum){
							ParamCandidateListLength = l+1;
							break;
						}
					}
				}
				
	        } else {
	        	tempSum=0;
				for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
					tempSum = tempSum + WeightParamAreaOrSquares[l];
				}
				if (tempSum == 0){
					ParamAreaOrSquares = rand.nextInt(2);
				} else {
					randomNum = rand.nextInt(tempSum) + 1;
					tempSum=0;
					for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
						tempSum = tempSum + WeightParamAreaOrSquares[l];
						if (tempSum>=randomNum){
							ParamAreaOrSquares = l;
							break;
						}
					}
				}
	        }
			
			stowagePlan.GRASPconstruction(stowagePlan.possibleSquares, Cargoes, ParamSearchDir, ParamRandom, ParamCandidateListLength, ParamAreaOrSquares);
			
			//Printing some information
			//System.out.println(n+ "   " + ParamSearchDir+ "   " + (ParamRandom) + " " + (ParamCandidateListLength) + "   " + ParamAreaOrSquares + "    " + stowagePlan.areaNotPlaced);
			
			if (stowagePlan.areaNotPlaced == 0){
				//System.out.println("VI ER FERDIG!! Area not placed = " + stowagePlan.areaNotPlaced);
				break;
			} else {
				//UPDATE WEIGHTS;
				
				if (n!=0){
					if (stowagePlan.areaNotPlaced>prevAreaNotPlaced){
						if (paramChoice == 0) {
							WeightParamSearchDir[ParamSearchDir]=WeightParamSearchDir[ParamSearchDir]-deltaWeight;
							if (WeightParamSearchDir[ParamSearchDir] < 100){
								WeightParamSearchDir[ParamSearchDir]=100;
							}
							//System.out.println("Searchdir reduced");
				        } else if (paramChoice == 1) {
				        	WeightParamRandom[randomChosen]=WeightParamRandom[randomChosen]-deltaWeight;
				        	//System.out.println("Random reduced");
				        	if (WeightParamRandom[randomChosen] < 100){
				        		WeightParamRandom[randomChosen]=100;
							}
				        } else if (paramChoice == 2) {
				        	WeightParamCandidateListLength[ParamCandidateListLength-1]=WeightParamCandidateListLength[ParamCandidateListLength-1]-deltaWeight;
				        	//System.out.println("List reduced");
				        	if (WeightParamCandidateListLength[ParamCandidateListLength-1] < 100){
				        		WeightParamCandidateListLength[ParamCandidateListLength-1]=100;
							}
				        } else {
				        	WeightParamAreaOrSquares[ParamAreaOrSquares]=WeightParamAreaOrSquares[ParamAreaOrSquares]-deltaWeight;
				        	//System.out.println("Obj reduced");
				        	if (WeightParamAreaOrSquares[ParamAreaOrSquares] < 100){
				        		WeightParamAreaOrSquares[ParamAreaOrSquares]=100;
							}
				        }
					}
					if (stowagePlan.areaNotPlaced<prevAreaNotPlaced){
						if (paramChoice == 0) {
							WeightParamSearchDir[ParamSearchDir]=WeightParamSearchDir[ParamSearchDir]+deltaWeight;
							//System.out.println("Searchdir increased");
				        } else if (paramChoice == 1) {
				        	WeightParamRandom[randomChosen]=WeightParamRandom[randomChosen]+deltaWeight;
				        	//System.out.println("Random increased");
				        } else if (paramChoice == 2) {
				        	WeightParamCandidateListLength[ParamCandidateListLength-1]=WeightParamCandidateListLength[ParamCandidateListLength-1]+deltaWeight;
				        	//System.out.println("List increased");
				        } else {
				        	WeightParamAreaOrSquares[ParamAreaOrSquares]=WeightParamAreaOrSquares[ParamAreaOrSquares]+deltaWeight;
				        	//System.out.println("Obj increased");
				        }
					}
				}
				
				prevAreaNotPlaced = stowagePlan.areaNotPlaced;
			}
		}
		//printParameters(WeightParamSearchDir,WeightParamRandom,WeightParamCandidateListLength,WeightParamAreaOrSquares);
		
		//totalIter = totalIter/maxRunTime;
		
		double dtotalIter = totalIter;
		double dmaxRunTime = maxRunTime;
		
		
		
		dtotalIter = 1000*dtotalIter/dmaxRunTime;
		
		
		System.out.println(dtotalIter);
	}


	
	
	
	public static void printParameters(int[] WeightParamSearchDir, int[] WeightParamRandom, int[] WeightParamCandidateListLength, int[] WeightParamAreaOrSquares){
		System.out.print("SearchDir: ");
		for (int l = 0; l < WeightParamSearchDir.length ; l++) {
			System.out.print(WeightParamSearchDir[l]+", ");
		}
		System.out.println();
		
		System.out.print("Random: ");
		for (int l = 0; l < WeightParamRandom.length ; l++) {
			System.out.print(WeightParamRandom[l]+", ");
		}
		System.out.println();
		
		System.out.print("List: ");
		for (int l = 0; l < WeightParamCandidateListLength.length ; l++) {
			System.out.print(WeightParamCandidateListLength[l]+", ");
		}
		System.out.println();
		
		System.out.print("Obj: ");
		for (int l = 0; l < WeightParamAreaOrSquares.length ; l++) {
			System.out.print(WeightParamAreaOrSquares[l]+", ");
		}
		System.out.println();
	}

}


