import java.util.Comparator;
import java.util.PriorityQueue;

class ShiftingResult {
	double totalShiftCost;
	double totalNumberOfShift;
	double[][][] numShift;
	double[][] numShiftCV;
	double[][] shiftCostCV;
	double[][][] routeCost;
	double[][][] numRouteLength;
	
	ShiftingResult(StowagePlan stowageplan){
		this.numShift = new double [stowageplan.nCargoes][stowageplan.maxVehicle][stowageplan.nPorts];
		this.numShiftCV = new double [stowageplan.nCargoes][stowageplan.maxVehicle];
		this.shiftCostCV = new double [stowageplan.nCargoes][stowageplan.maxVehicle];
		this.routeCost = new double [stowageplan.nCargoes][stowageplan.maxVehicle][2];
		this.numRouteLength = new double [stowageplan.nCargoes][stowageplan.maxVehicle][2];
	}
	


	void dijkstramedtid(StowagePlan stowageplan, int[][][]possibleSquaresWithExit,Cargo[] Cargoes){

		//Set initial condition for the shifting result variabels
		totalShiftCost = 0;
		totalNumberOfShift = 0;
		
		for(int c = 0; c < stowageplan.nCargoes; c++){
			for(int v = 0; v < Cargoes[c].NumberVehicle; v++){
				for(int q = 0; q < stowageplan.nPorts; q++){
					numShift[c][v][q] = 0;
					shiftCostCV[c][v] = 0;
				}
				for(int p = 0; p < 2; p++){
					routeCost[c][v][p] = 0;
					numRouteLength[c][v][p] = 0;
				}
			}
		}
		
	
		int nRows = stowageplan.nRows;
		int nCols = stowageplan.nColumns;
		int nCargoes = stowageplan.nCargoes;
		int maxVehicle = stowageplan.maxVehicle;
		int nPorts = stowageplan.nPorts;

		int exit_i = 11;
		int exit_j = 14;
		long startTime = System.currentTimeMillis();
		int bigInt = nRows*nCols;
		
		Vertex[][][][] Vertices= new Vertex[nRows][nCols][nCargoes][2];
		
		Comparator<Vertex> comparator = new DistComparator();
		PriorityQueue<Vertex> pq1 = new PriorityQueue<Vertex>(comparator);
		
		for(int i = 0; i < nRows; i++){
			for(int j = 0; j < nCols; j++){
				for(int c = 0; c < nCargoes ; c++){
						for(int p1 = 0; p1 < 2; p1++){
							Vertices[i][j][c][p1] = new Vertex(i,j);
							Vertices[i][j][c][p1].Dist = bigInt;
						}
				}
			}
		}
		System.out.println("Tid fr incargo: " + (System.currentTimeMillis()-startTime));
		boolean[][][][][][] inCargoIJC;
		inCargoIJC = new boolean[2][nCols][1][nCargoes][maxVehicle][2];
		System.out.println("Tid etter incargo: " + (System.currentTimeMillis()-startTime));
		
		int[][][] counterDW;
		counterDW = new int [nCargoes][maxVehicle][nPorts];
		
		int p = 0; //Loading-0 or Unloading-1
		int q = 0; //Amount of ports
		
		
		
		
		
		int tempC=0;
		int tempI=0;
		int tempP=0;
		System.out.println("Tid fr edgecostcalc: " + (System.currentTimeMillis()-startTime));
		for(q = 1; q < nPorts-1; q++){
			for(int c = 0; c < nCargoes; c++){
				if (Cargoes[c].LoadingPort-1==q) {
					p = 0;
				} else { 
					p=1;
				}
				if (Cargoes[c].LoadingPort-1==q || Cargoes[c].UnloadingPort-1==q){
					for(int i = 0; i < nRows; i++){
						for(int j = 0; j < nCols; j++){
							//HER ER LITT TEST
							if (c != tempC){
								for(int j1 = 0; j1 < nCols; j1++){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											inCargoIJC[0][j1][0][d][v][p]=false;
											inCargoIJC[1][j1][0][d][v][p]=false;
										}
									}
								}
								tempC = c;
							}
							if (i != tempI){
								for(int j1 = 0; j1 < nCols; j1++){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											inCargoIJC[0][j1][0][d][v][p]=inCargoIJC[1][j1][0][d][v][p];
											inCargoIJC[1][j1][0][d][v][p]=false;
										}
									}
								}
								tempI = i;
							}
							if (p != tempP){
								for(int j1 = 0; j1 < nCols; j1++){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											inCargoIJC[0][j1][0][d][v][p]=inCargoIJC[1][j1][0][d][v][p];
											inCargoIJC[1][j1][0][d][v][p]=false;
										}
									}
								}
								tempP = p;
							}
							if (possibleSquaresWithExit[i][j][c]==1){
								for(int a = i; a < i+Cargoes[c].SquaresL;a++){
									for(int b = j; b < j+Cargoes[c].SquaresW; b++){
										if (stowageplan.vehiclePlacements[a][b].empty==0){
											int loadingPortC = Cargoes[c].LoadingPort;
											int loadingPortD = Cargoes[stowageplan.vehiclePlacements[a][b].cargo].LoadingPort;
											int unloadingPortC = Cargoes[c].UnloadingPort;
											int unloadingPortD = Cargoes[stowageplan.vehiclePlacements[a][b].cargo].UnloadingPort;
											if ( (p==0 && loadingPortD<loadingPortC) || (p==1 && unloadingPortD>unloadingPortC) ){
											inCargoIJC[1][j][0][stowageplan.vehiclePlacements[a][b].cargo][stowageplan.vehiclePlacements[a][b].vehicle][p] = true;
											}											
										}
									}
								}
								//Her gjr vi noe
								if(j>0){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											if (inCargoIJC[1][j-1][0][d][v][p] == true && inCargoIJC[1][j][0][d][v][p] == false){
												Vertices[i][j][c][p].EdgeCost[3]=Vertices[i][j][c][p].EdgeCost[3]+Cargoes[d].Area;
											}
											if (inCargoIJC[1][j][0][d][v][p] == true && inCargoIJC[1][j-1][0][d][v][p] == false){
												Vertices[i][j-1][c][p].EdgeCost[1]=Vertices[i][j-1][c][p].EdgeCost[1]+Cargoes[d].Area;
											}
										}
									}
								}
								if(i>0){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											if (inCargoIJC[0][j][0][d][v][p] == true && inCargoIJC[1][j][0][d][v][p] == false){
												Vertices[i][j][c][p].EdgeCost[2]=Vertices[i][j][c][p].EdgeCost[2]+Cargoes[d].Area;
											}
											if (inCargoIJC[1][j][0][d][v][p] == true && inCargoIJC[0][j][0][d][v][p] == false){
												Vertices[i-1][j][c][p].EdgeCost[0]=Vertices[i-1][j][c][p].EdgeCost[0]+Cargoes[d].Area;
											}
										}
									}
								}
								} else {
									if(i+1<nRows){
										Vertices[i][j][c][p].EdgeCost[0]= bigInt;
										Vertices[i+1][j][c][p].EdgeCost[2]= bigInt;
									}
									if(j+1<nCols){
										Vertices[i][j][c][p].EdgeCost[1]= bigInt;
										Vertices[i][j+1][c][p].EdgeCost[3]= bigInt;
									}	
									if(i>0){
										Vertices[i][j][c][p].EdgeCost[2]= bigInt;
										Vertices[i-1][j][c][p].EdgeCost[0]= bigInt;
									}
									if(j>0){
										Vertices[i][j][c][p].EdgeCost[3]= bigInt;
										Vertices[i][j-1][c][p].EdgeCost[1]= bigInt;
									}
								}
							}
						}
					}
				}
			}
				
		// Fr dette setter vi kun edgecost
		// Her er vi ute av alle loops.
		
		System.out.println("Tid etter edgecostcalc: " + (System.currentTimeMillis()-startTime));
		
		System.out.println("Tid fr dijkstraparameterlaging: " + (System.currentTimeMillis()-startTime));
		int temp_i = 0;
		int temp_j = 0;
		double alt = 0;
		//int test = 0;
		System.out.println("Tid fr dijkstrautregning: " + (System.currentTimeMillis()-startTime));
		
		for(p = 0; p< 2; p++){
			for(int c = 0; c < nCargoes; c++){
				if (c<stowageplan.nCargoesM || (c>=stowageplan.nCargoesM && stowageplan.OptionalSetEvaluated.CargoesCarried[c-stowageplan.nCargoesM]==1)){
					if (pq1.isEmpty()){
					} else {
						pq1.clear();
					}
					
					Vertices[exit_i][exit_j][c][p].Dist = 0;
					pq1.offer(Vertices[exit_i][exit_j][c][p]);
					//while(sum(vertex, Row, Col, c, p1) != 0){
					while (pq1.isEmpty()==false){
							temp_i=pq1.peek().i;
							temp_j=pq1.poll().j;
							for(int n = 0; n < 4; n++){
								alt = Vertices[temp_i][temp_j][c][p].Dist + Vertices[temp_i][temp_j][c][p].EdgeCost[n] + 0.0001;
								if(n == 0 && temp_i < nRows-1){
									if(alt < Vertices[temp_i +1][temp_j][c][p].Dist){
										Vertices[temp_i +1][temp_j][c][p].Dist = alt;
										Vertices[temp_i +1][temp_j][c][p].prevI = temp_i;
										Vertices[temp_i +1][temp_j][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i +1][temp_j][c][p]);
									}
								}
								if(n == 1 && temp_j < nCols-1){
									if(alt < Vertices[temp_i][temp_j + 1][c][p].Dist){
										Vertices[temp_i][temp_j + 1][c][p].Dist = alt;
										Vertices[temp_i][temp_j + 1][c][p].prevI = temp_i;
										Vertices[temp_i][temp_j + 1][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i][temp_j + 1][c][p]);
									}
								}
								if(n == 2 && temp_i>0){
									if(alt < Vertices[temp_i - 1][temp_j][c][p].Dist){
										Vertices[temp_i - 1][temp_j][c][p].Dist = alt;
										Vertices[temp_i - 1][temp_j][c][p].prevI = temp_i;
										Vertices[temp_i - 1][temp_j][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i - 1][temp_j][c][p]);
									}
								}
								if(n == 3 && temp_j>0){
									if(alt < Vertices[temp_i][temp_j - 1][c][p].Dist){
										Vertices[temp_i][temp_j - 1][c][p].Dist = alt;
										Vertices[temp_i][temp_j - 1][c][p].prevI = temp_i;
										Vertices[temp_i][temp_j - 1][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i][temp_j - 1][c][p]);
									}
								}
								//System.out.print("(" + prev[i][j][c][p1][0] + "," + prev[i][j][c][p1][1] + ") -");
							}
						}
					
				}
				//Her jobber vi for hver port og hver cargo. Vet p og c her.
				
				
			}
		}
		System.out.println("Tid etter dijkstrautregning: " + (System.currentTimeMillis()-startTime));	
		//Ute av alle loops.
		
		for(p = 0; p < 2; p++){
			for(int i = 0; i < nRows; i++){
				for(int j = 0; j < nCols; j++){
					if (stowageplan.vehiclePlacements[i][j].empty==0 && ((Cargoes[stowageplan.vehiclePlacements[i][j].cargo].LoadingPort!=1 && p==0) || (Cargoes[stowageplan.vehiclePlacements[i][j].cargo].UnloadingPort!=nPorts && p==1))){
						
						int c = stowageplan.vehiclePlacements[i][j].cargo;
						int v = stowageplan.vehiclePlacements[i][j].vehicle;
						
						if (stowageplan.flowX[i][j][c]==1){
							int mid_i = i;
							int mid_j = j;
							int mid2_i = 0;
							
							//System.out.print("C" + c + "V" + v);
							if (p == 0){
								//System.out.println(" Loading " + Cargoes[c].LoadingPort);
							} else {
								//System.out.println(" Unloading " + Cargoes[c].UnloadingPort);
							}
							if (p==0){
								q = Cargoes[c].LoadingPort-1;
							} else {
								q = Cargoes[c].UnloadingPort-1;
							}
							while (mid_i!=exit_i || mid_j!=exit_j){
								//System.out.print("(" + mid_i + "," + mid_j + ") - ");
								mid2_i = mid_i;
								mid_i=Vertices[mid_i][mid_j][c][p].prevI;
								mid_j=Vertices[mid2_i][mid_j][c][p].prevJ;
								
								for(int ii = mid_i; ii < mid_i+Cargoes[c].SquaresL; ii++){
									for(int jj = mid_j; jj < mid_j+Cargoes[c].SquaresW; jj++){
										if (stowageplan.vehiclePlacements[ii][jj].empty==0){
											int loadingPortC = Cargoes[c].LoadingPort;
											int loadingPortD = Cargoes[stowageplan.vehiclePlacements[ii][jj].cargo].LoadingPort;
											int unloadingPortC = Cargoes[c].UnloadingPort;
											int unloadingPortD = Cargoes[stowageplan.vehiclePlacements[ii][jj].cargo].UnloadingPort;
											int d = stowageplan.vehiclePlacements[ii][jj].cargo;
											int w = stowageplan.vehiclePlacements[ii][jj].vehicle;
											if ( (p==0 && loadingPortD<loadingPortC) || (p==1 && unloadingPortD>unloadingPortC) ){
												if (counterDW[d][w][q]==0){
													numShift[d][w][q] = numShift[d][w][q] + 1;
													routeCost[c][v][p] = routeCost[c][v][p] + Cargoes[d].Area;
													numRouteLength[c][v][p] = numRouteLength[c][v][p] + 1;
													counterDW[d][w][q] = 1;
												}
											}
										}
									}
								}
							}
							for(int d = 0; d < nCargoes; d++){
								for(int w = 0; w < Cargoes[d].NumberVehicle; w++){
									counterDW[d][w][q] = 0;
								}
							}
							//System.out.print("(" + exit_i + "," + exit_j + ")");
							//System.out.println();
							//System.out.println();
						}
					}
				}
			}
		}
		for(int c = 0; c < nCargoes; c++){
			for(int v = 0; v < Cargoes[c].NumberVehicle; v++){
				for(q = 0; q < nPorts; q++){
					if(numShift[c][v][q] >= 1){
						totalShiftCost = totalShiftCost + Cargoes[c].Area;
						totalNumberOfShift = totalNumberOfShift + 1;
						shiftCostCV[c][v] = shiftCostCV[c][v] + Cargoes[c].Area;
						numShiftCV[c][v] = numShiftCV[c][v] + numShift[c][v][q];
					}
				}
			}
		}
	}
		


	void dijkstra(StowagePlan stowageplan, int[][][]possibleSquaresWithExit,Cargo[] Cargoes, int exitI, int exitJ){
		//Set initial condition for the shifting result variabels
		totalShiftCost = 0;
		totalNumberOfShift = 0;
		long startTime = System.currentTimeMillis();
		for(int c = 0; c < stowageplan.nCargoes; c++){
			for(int v = 0; v < Cargoes[c].NumberVehicle; v++){
				for(int q = 0; q < stowageplan.nPorts; q++){
					numShift[c][v][q] = 0;
					shiftCostCV[c][v] = 0;
				}
				for(int p = 0; p < 2; p++){
					routeCost[c][v][p] = 0;
					numRouteLength[c][v][p] = 0;
				}
			}
		}
		
	
		int nRows = stowageplan.nRows;
		int nCols = stowageplan.nColumns;
		int nCargoes = stowageplan.nCargoes;
		int maxVehicle = stowageplan.maxVehicle;
		int nPorts = stowageplan.nPorts;

		int exit_i = exitI;
		int exit_j = exitJ;
		int bigInt = nRows*nCols;
		
		Vertex[][][][] Vertices= new Vertex[nRows][nCols][nCargoes][2];
		
		Comparator<Vertex> comparator = new DistComparator();
		PriorityQueue<Vertex> pq1 = new PriorityQueue<Vertex>(comparator);
		
		for(int i = 0; i < nRows; i++){
			for(int j = 0; j < nCols; j++){
				for(int c = 0; c < nCargoes ; c++){
						for(int p1 = 0; p1 < 2; p1++){
							Vertices[i][j][c][p1] = new Vertex(i,j);
							Vertices[i][j][c][p1].Dist = bigInt;
						}
				}
			}
		}
		
		boolean[][][][][][] inCargoIJC;
		inCargoIJC = new boolean[2][nCols][1][nCargoes][maxVehicle][2];
		
		int[][][] counterDW;
		counterDW = new int [nCargoes][maxVehicle][nPorts];
		
		int p = 0; //Loading-0 or Unloading-1
		int q = 0; //Amount of ports
		
		
		
		int[] crashingCargo = new int [stowageplan.nCargoes];
		int tempC=0;
		int tempI=0;
		//System.out.println("EDGE" + (System.currentTimeMillis()-startTime));
		for(q = 1; q < nPorts-1; q++){
			for(int c = 0; c < nCargoes; c++){
				if (Cargoes[c].LoadingPort-1==q) {
					p = 0;
				} else { 
					p=1;
				}
				if ((Cargoes[c].LoadingPort-1==q || Cargoes[c].UnloadingPort-1==q) && (c<stowageplan.nCargoesM || (c>=stowageplan.nCargoesM && stowageplan.OptionalSetEvaluated.CargoesCarried[c-stowageplan.nCargoesM]==1))){
					//System.out.println("Vi er her: " + tempP++ + "      " + (System.currentTimeMillis()-startTime));
					for(int i = 0; i < nRows; i++){
						for(int j = 0; j < nCols; j++){
							//HER ER LITT TEST
							
							
							
							if (c != tempC){
								for(int j1 = 0; j1 < nCols; j1++){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											inCargoIJC[0][j1][0][d][v][p]=false;
											inCargoIJC[1][j1][0][d][v][p]=false;
										}
									}
								}
								tempC = c;
							}
							
							if (i != tempI){
								
								for(int j1 = 0; j1 < nCols; j1++){
									for(int d = 0; d < nCargoes; d++){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											inCargoIJC[0][j1][0][d][v][p]=inCargoIJC[1][j1][0][d][v][p];
											inCargoIJC[1][j1][0][d][v][p]=false;
										}
									}
								}
								tempI = i;
							}
							
							
							if (possibleSquaresWithExit[i][j][c]==1){
								for(int a = i; a < i+Cargoes[c].SquaresL;a++){
									for(int b = j; b < j+Cargoes[c].SquaresW; b++){
										if (stowageplan.vehiclePlacements[a][b].empty==0){
											crashingCargo[stowageplan.vehiclePlacements[a][b].cargo] = 0;
											int loadingPortC = Cargoes[c].LoadingPort;
											int loadingPortD = Cargoes[stowageplan.vehiclePlacements[a][b].cargo].LoadingPort;
											int unloadingPortC = Cargoes[c].UnloadingPort;
											int unloadingPortD = Cargoes[stowageplan.vehiclePlacements[a][b].cargo].UnloadingPort;
											if ( (p==0 && loadingPortD<loadingPortC) || (p==1 && unloadingPortD>unloadingPortC) ){
												inCargoIJC[1][j][0][stowageplan.vehiclePlacements[a][b].cargo][stowageplan.vehiclePlacements[a][b].vehicle][p] = true;
												crashingCargo[stowageplan.vehiclePlacements[a][b].cargo] = 1;
											}											
										}
									}
								}
								
								for(int d = 0; d < nCargoes; d++){
									if (crashingCargo[d]==1 && j>0){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											if (inCargoIJC[1][j-1][0][d][v][p] == true && inCargoIJC[1][j][0][d][v][p] == false){
												Vertices[i][j][c][p].EdgeCost[3]=Vertices[i][j][c][p].EdgeCost[3]+Cargoes[d].Area;
											}
											if (inCargoIJC[1][j][0][d][v][p] == true && inCargoIJC[1][j-1][0][d][v][p] == false){
												Vertices[i][j-1][c][p].EdgeCost[1]=Vertices[i][j-1][c][p].EdgeCost[1]+Cargoes[d].Area;
											}
										}
									}
									if (crashingCargo[d]==1 && i>0){
										for(int v = 0; v < Cargoes[d].NumberVehicle; v++){
											if (inCargoIJC[0][j][0][d][v][p] == true && inCargoIJC[1][j][0][d][v][p] == false){
												Vertices[i][j][c][p].EdgeCost[2]=Vertices[i][j][c][p].EdgeCost[2]+Cargoes[d].Area;
											}
											if (inCargoIJC[1][j][0][d][v][p] == true && inCargoIJC[0][j][0][d][v][p] == false){
												Vertices[i-1][j][c][p].EdgeCost[0]=Vertices[i-1][j][c][p].EdgeCost[0]+Cargoes[d].Area;
											}
										}	
									}
								}
								
							} else {
								if(i+1<nRows){
									Vertices[i][j][c][p].EdgeCost[0]= bigInt;
									Vertices[i+1][j][c][p].EdgeCost[2]= bigInt;
								}
								if(j+1<nCols){
									Vertices[i][j][c][p].EdgeCost[1]= bigInt;
									Vertices[i][j+1][c][p].EdgeCost[3]= bigInt;
								}	
								if(i>0){
									Vertices[i][j][c][p].EdgeCost[2]= bigInt;
									Vertices[i-1][j][c][p].EdgeCost[0]= bigInt;
								}
								if(j>0){
									Vertices[i][j][c][p].EdgeCost[3]= bigInt;
									Vertices[i][j-1][c][p].EdgeCost[1]= bigInt;
								}
							}
						}
					}
				}
			}
		}
				
		// Fr dette setter vi kun edgecost
		// Her er vi ute av alle loops.
		
		
		int temp_i = 0;
		int temp_j = 0;
		double alt = 0;
		//int test = 0;
		//System.out.println("DISJKSTRA: " + (System.currentTimeMillis()-startTime));
		for(p = 0; p< 2; p++){
			for(int c = 0; c < nCargoes; c++){
				if (c<stowageplan.nCargoesM || (c>=stowageplan.nCargoesM && stowageplan.OptionalSetEvaluated.CargoesCarried[c-stowageplan.nCargoesM]==1)){
					if (pq1.isEmpty()){
					} else {
						pq1.clear();
					}
					
					Vertices[exit_i][exit_j][c][p].Dist = 0;
					pq1.offer(Vertices[exit_i][exit_j][c][p]);
					//while(sum(vertex, Row, Col, c, p1) != 0){
					while (pq1.isEmpty()==false){
							temp_i=pq1.peek().i;
							temp_j=pq1.poll().j;
							for(int n = 0; n < 4; n++){
								alt = Vertices[temp_i][temp_j][c][p].Dist + Vertices[temp_i][temp_j][c][p].EdgeCost[n] + 0.0001;
								if(n == 0 && temp_i < nRows-1){
									if(alt < Vertices[temp_i +1][temp_j][c][p].Dist){
										Vertices[temp_i +1][temp_j][c][p].Dist = alt;
										Vertices[temp_i +1][temp_j][c][p].prevI = temp_i;
										Vertices[temp_i +1][temp_j][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i +1][temp_j][c][p]);
									}
								}
								if(n == 1 && temp_j < nCols-1){
									if(alt < Vertices[temp_i][temp_j + 1][c][p].Dist){
										Vertices[temp_i][temp_j + 1][c][p].Dist = alt;
										Vertices[temp_i][temp_j + 1][c][p].prevI = temp_i;
										Vertices[temp_i][temp_j + 1][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i][temp_j + 1][c][p]);
									}
								}
								if(n == 2 && temp_i>0){
									if(alt < Vertices[temp_i - 1][temp_j][c][p].Dist){
										Vertices[temp_i - 1][temp_j][c][p].Dist = alt;
										Vertices[temp_i - 1][temp_j][c][p].prevI = temp_i;
										Vertices[temp_i - 1][temp_j][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i - 1][temp_j][c][p]);
									}
								}
								if(n == 3 && temp_j>0){
									if(alt < Vertices[temp_i][temp_j - 1][c][p].Dist){
										Vertices[temp_i][temp_j - 1][c][p].Dist = alt;
										Vertices[temp_i][temp_j - 1][c][p].prevI = temp_i;
										Vertices[temp_i][temp_j - 1][c][p].prevJ = temp_j;
										pq1.offer(Vertices[temp_i][temp_j - 1][c][p]);
									}
								}
							}
						}
					
				}
				//Her jobber vi for hver port og hver cargo. Vet p og c her.
				
				
			}
		}
		//Ute av alle loops.
		//System.out.println("EXITROUTE" + (System.currentTimeMillis()-startTime));
		for(p = 0; p < 2; p++){
			for(int i = 0; i < nRows; i++){
				for(int j = 0; j < nCols; j++){
					if (stowageplan.vehiclePlacements[i][j].empty==0 && ((Cargoes[stowageplan.vehiclePlacements[i][j].cargo].LoadingPort!=1 && p==0) || (Cargoes[stowageplan.vehiclePlacements[i][j].cargo].UnloadingPort!=nPorts && p==1))){
						
						int c = stowageplan.vehiclePlacements[i][j].cargo;
						int v = stowageplan.vehiclePlacements[i][j].vehicle;
						
						if (stowageplan.flowX[i][j][c]==1){
							int mid_i = i;
							int mid_j = j;
							int mid2_i = 0;
							
							//System.out.print("C" + c + "V" + v);
							if (p == 0){
								//System.out.println(" Loading " + Cargoes[c].LoadingPort);
							} else {
								//System.out.println(" Unloading " + Cargoes[c].UnloadingPort);
							}
							if (p==0){
								q = Cargoes[c].LoadingPort-1;
							} else {
								q = Cargoes[c].UnloadingPort-1;
							}
							while (mid_i!=exit_i || mid_j!=exit_j){
								//System.out.print("(" + mid_i + "," + mid_j + ") - ");
								mid2_i = mid_i;
								mid_i=Vertices[mid_i][mid_j][c][p].prevI;
								mid_j=Vertices[mid2_i][mid_j][c][p].prevJ;
								
								for(int ii = mid_i; ii < mid_i+Cargoes[c].SquaresL; ii++){
									for(int jj = mid_j; jj < mid_j+Cargoes[c].SquaresW; jj++){
										if (stowageplan.vehiclePlacements[ii][jj].empty==0){
											int loadingPortC = Cargoes[c].LoadingPort;
											int loadingPortD = Cargoes[stowageplan.vehiclePlacements[ii][jj].cargo].LoadingPort;
											int unloadingPortC = Cargoes[c].UnloadingPort;
											int unloadingPortD = Cargoes[stowageplan.vehiclePlacements[ii][jj].cargo].UnloadingPort;
											int d = stowageplan.vehiclePlacements[ii][jj].cargo;
											int w = stowageplan.vehiclePlacements[ii][jj].vehicle;
											if ( (p==0 && loadingPortD<loadingPortC) || (p==1 && unloadingPortD>unloadingPortC) ){
												if (counterDW[d][w][q]==0){
													numShift[d][w][q] = numShift[d][w][q] + 1;
													routeCost[c][v][p] = routeCost[c][v][p] + Cargoes[d].Area;
													numRouteLength[c][v][p] = numRouteLength[c][v][p] + 1;
													counterDW[d][w][q] = 1;
												}
											}
										}
									}
								}
							}
							for(int d = 0; d < nCargoes; d++){
								for(int w = 0; w < Cargoes[d].NumberVehicle; w++){
									counterDW[d][w][q] = 0;
								}
							}
							//System.out.print("(" + exit_i + "," + exit_j + ")");
							//System.out.println();
							//System.out.println();
						}
					}
				}
			}
		}
		for(int c = 0; c < nCargoes; c++){
			for(int v = 0; v < Cargoes[c].NumberVehicle; v++){
				for(q = 0; q < nPorts; q++){
					if(numShift[c][v][q] >= 1){
						totalShiftCost = totalShiftCost + Cargoes[c].Area;
						totalNumberOfShift = totalNumberOfShift + 1;
						shiftCostCV[c][v] = shiftCostCV[c][v] + Cargoes[c].Area;
						numShiftCV[c][v] = numShiftCV[c][v] + numShift[c][v][q];
					}
				}
			}
		}
		//System.out.println("SLUTT" + (System.currentTimeMillis()-startTime));
	}
		


	
	
}